Ext.define('DSS.component.TimeReference', {
    extend : 'DSS.component.Base',
    oDatePanel:null,
    oLimitPanel:null,
    oDeltaCylcer:null,
    oDateTypeCylcer :null,
    oControlHour :null,
    oControlMinute:null,
    lblAnzeige:null,
    oLimitType:null,
    oLimitHour:null,
    oLimitMinute:null,
    lblLimitAnzeige:null,
    lblSummary:null,
    nowDawn:null,
    nowDusk:null,
    nowSunset:null,
    nowSunrise:null,
    oControlRandom:null,
    pnlDiff:null,
    randomize:null,
    referenceChangeListener:null,
    constructor : function (config) {
        

        this.lblSummary = Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:'(hh:mm)',
            width:600,
            padding: "0 0 7 10"
        });
        this.lblAnzeige = Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:'(hh:mm)',
            margin: "0 10 0 0"
        });
        this.lblLimitAnzeige = Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:'Uhr',
            hidden:true
        });
        this.oDatePanel = Ext.create('Ext.form.FieldContainer', {
            fieldLabel : config.label,
            labelWidth : 80,
            border : 1,
            margin : '0 0 0 10',
            layout : 'column'
        });
        this.oLimitPanel = Ext.create('Ext.form.FieldContainer', {
            fieldLabel : "&#160;",
            labelSeparator:'',
            labelWidth : 80,
            border : 1,
            layout : 'column',
            padding: "5 0 0 0"
        });
        this.randomize=config.randomize;
        if (this.randomize) {
            this.oControlRandom = Ext.create(
                    'Ext.form.field.Checkbox',
                    {   labelWidth:90,
                        labelSeparator:'',
                        fieldLabel:'&nbsp;',
                        boxLabel : 'Zeit zuf&auml;llig um &plusmn;15 Minuten variieren.',
                        padding: "6 0 0 0"
                    });
        }
        if (config.referenceChangeListener!=null)
            this.referenceChangeListener=config.referenceChangeListener;
        else
            this.referenceChangeListener=null;
        this.oLimitType = Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 10',
            menu : {
                items : [ {
                    checked : true,
                    itemId : 'chk-limitNo',
                    text : _('no restrictions')
                },{
                    itemId : 'chk-limitBefore',
                    text : _('not later than')
                }, {
                    itemId : 'chk-limitAfter',
                    text :  _('not before')
                } ]
            },
            listeners: {
                change: function(btn,item) {
                    btn.up().up().oLimitHour.setVisible(item.getItemId()!='chk-limitNo');
                    btn.up().up().oLimitMinute.setVisible(item.getItemId()!='chk-limitNo');
                    btn.up().up().lblLimitAnzeige.setVisible(item.getItemId()!='chk-limitNo');
                    btn.up().up().oLimitHour.setValue(0);
                    btn.up().up().oLimitMinute.setValue(0);
                }
            },
            showText : true,
            width : 150
        });
        this.oLimitHour = Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            width : 43,
            margin : '0 5 0 0',
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 23,
            hidden:true
        });
        this.oLimitMinute = Ext.create('Ext.form.field.Number', {
            width : 43,
            allowBlank : false,
            margin : '0 5 0 0',
            value : 0,
            minValue : 0,
            maxValue : 59,
            hidden:true      
        });     
        
        this.oDeltaCylcer= Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 0',
            menu : {
                items : [ {
                    checked : true,
                    itemId : 'chk-before',
                    text : _('earlier')
                }, {
                    itemId : 'chk-after',
                    text : _('later')

                } ]
            },
            showText : true,
            width : 100,
            hidden:true
        });
     
        
        var oDateTypeItemArray = [ {
            checked : true,
            itemId : 'chk-time',
            text : _('fixed time')
        }, {
            itemId : 'chk-sunrise',
            text : _('sunrise')

        } , {
            itemId : 'chk-sunset',
            text : _('sunset')

        }, {
            itemId : 'chk-dawn',
            text : _('dawn')

        }, {
            itemId : 'chk-dusk',
            text : _('dusk')

        } ];
        
        if (config.additionalAbsoluteValues!=null) {
            for (var iIndex=0;iIndex<config.additionalAbsoluteValues.length;iIndex++) {
                oDateTypeItemArray.push({itemId:config.additionalAbsoluteValues[iIndex].id,
                                         text: _(config.additionalAbsoluteValues[iIndex].label)});
            }
        }
        
        this.oDateTypeCylcer = Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 0',
            menu : {
                items : oDateTypeItemArray
            },
            showText : true,
            width : 150,
            listeners : {
                change : function(btn,item) {
                    var basePanel=this.up().up();
                    if ((basePanel.oDeltaCylcer.isVisible()) && (item.getItemId()=='chk-time')){
                        basePanel.oControlHour.setValue(12);                  
                        basePanel.oControlMinute.setValue(0);                       
                    } 
                    if ((!basePanel.oDeltaCylcer.isVisible()) && (item.getItemId()!='chk-time')){
                        basePanel.oControlHour.setValue(0);                  
                        basePanel.oControlMinute.setValue(0);
                    }
                    basePanel.oDeltaCylcer.setVisible(item.getItemId()!='chk-time');
                    basePanel.oLimitPanel.setVisible(item.getItemId()!='chk-time');
                    basePanel.doLayout();
                    basePanel.updateSummary();
                    if (basePanel.referenceChangeListener!=null)
                        basePanel.referenceChangeListener(basePanel.dssEditor,basePanel,item.getItemId());
                }
            }
        });
        
        this.oControlHour = Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            width : 43,
            margin : '0 5 0 0',
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 23
        });
        this.oControlMinute = Ext.create('Ext.form.field.Number', {
            width : 43,
            allowBlank : false,
            margin : '0 5 0 0',
            value : 0,
            minValue : 0,
            maxValue : 59      
        });     
        this.pnlDiff = Ext.create('Ext.panel.Panel', {
            heigth : 0,
            border : "1 0 0 0",
            width : "100%",
            padding: "7 0 15 0"
         });
        
        this.oLimitPanel.add(this.oLimitType);
        this.oLimitPanel.add(this.oLimitHour);
        this.oLimitPanel.add(this.oLimitMinute);
        this.oLimitPanel.add(this.lblLimitAnzeige);
        
        this.oDatePanel.add(this.oDateTypeCylcer);
        this.oDatePanel.add(this.oControlHour);
        this.oDatePanel.add(this.oControlMinute);         
        this.oDatePanel.add(this.lblAnzeige);
        
        this.oDatePanel.add(this.oDeltaCylcer);
        var oItemsArray=[this.lblSummary, this.pnlDiff, this.oDatePanel ,this.oLimitPanel];
        if (this.randomize!=null)
            oItemsArray.push(this.oControlRandom);
        Ext.apply(this, {           
            items : oItemsArray
        });
        var me=this;
        var oReplay=function() {me.updateSummary()};
        
        var oUpdate=function(sString) {me.getDateValues(sString)};
        window.setInterval(oReplay,30*1000);
        me.updateSummary();
        dss.ajaxAssyncRequestWithoutAnswer('/json/property/query',{query:'/config/geodata(sunset,sunrise,civil_dawn,civil_dusk)'},oUpdate)
        this.callParent(arguments);              
    },
    getDateValues:function(sString){
        var result = Ext.JSON.decode(sString);
        if (result.ok) {
            this.nowDawn=result.result.geodata[0].civil_dawn;
            this.nowDusk=result.result.geodata[0].civil_dusk;
            this.nowSunrise=result.result.geodata[0].sunrise;
            this.nowSunset=result.result.geodata[0].sunset;
        }
    },
    updateSummary:function(){
        var oNow=new Date();
        var sText=Ext.String.format2(_("Time now: {TimeNow}"),{TimeNow:Ext.Date.format(oNow, "H:i")});

        switch (this.oDateTypeCylcer.getActiveItem().getItemId()) {
            case 'chk-sunrise':
                sText+=Ext.String.format2(_(" Sunrise of the present day at {time}"),{time:this.nowSunrise});
                break;
            case 'chk-sunset':
                sText+=Ext.String.format2(_(" Sunset of the present day at {time}"),{time:this.nowSunset}); 
                break;
            case 'chk-dawn':
                sText+=Ext.String.format2(_(" Dawn of the present day at {time}"),{time:this.nowDawn});
                break;
            case 'chk-dusk':
                sText+=Ext.String.format2(_(" Dusk of the present day at {time}"),{time:this.nowDusk});
                break;
        }
        this.lblSummary.setValue(sText);
    },
    reset:function(){
        this.oDateTypeCylcer.setActiveItem('chk-time');
        this.oLimitType.setActiveItem('chk-limitNo');
        this.oDeltaCylcer.setActiveItem('chk-after');
        this.oControlHour.setValue(12);                  
        this.oControlMinute.setValue(0);
        this.oLimitHour.setValue(0);
        this.oLimitMinute.setValue(0);
        if (this.randomize!=null)
            this.oControlRandom.setValue(false);
    },
    setValue:function (value) {
        var sec = Math.abs(value.offset%60);
        var min = Math.floor(Math.abs(value.offset) / 60) % 60;
        var hou = Math.floor(Math.abs(value.offset) / 3600);
        if (value.offset<0)
            this.oDeltaCylcer.setActiveItem('chk-before');
        else
            this.oDeltaCylcer.setActiveItem('chk-after');     
        switch (value.timeBase)
        {
            case 'daily':
                this.oDateTypeCylcer.setActiveItem('chk-time');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);                  
            break;
            case 'sunset':
                this.oDateTypeCylcer.setActiveItem('chk-sunset');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);          
            break;
            case 'sunrise':
                this.oDateTypeCylcer.setActiveItem('chk-sunrise');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);                  
            break;
            case 'dusk':
                this.oDateTypeCylcer.setActiveItem('chk-dusk');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);                  
            break;
            case 'dawn':
                this.oDateTypeCylcer.setActiveItem('chk-dawn');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);                  
            break;
            default:
                this.oDateTypeCylcer.setActiveItem(value.timeBase);
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);                  
            break;
        }

        if (value.limitAfter!=null)
        {
            this.oLimitType.setActiveItem('chk-limitAfter');
            var secLimit = Math.abs(value.limitAfter%60);
            var minLimit = Math.floor(Math.abs(value.limitAfter) / 60) % 60;
            var houLimit = Math.floor(Math.abs(value.limitAfter) / 3600);
            this.oLimitMinute.setValue(minLimit);
            this.oLimitHour.setValue(houLimit);
        } else if (value.limitBefore!=null)
        {
            this.oLimitType.setActiveItem('chk-limitBefore');
            var secLimit = Math.abs(value.limitBefore%60);
            var minLimit = Math.floor(Math.abs(value.limitBefore) / 60) % 60;
            var houLimit = Math.floor(Math.abs(value.limitBefore) / 3600);
            this.oLimitMinute.setValue(minLimit);
            this.oLimitHour.setValue(houLimit);
        } else {
            this.oLimitType.setActiveItem('chk-limitNo');
        }
        
        if (this.randomize!=null) {            
            if (value.random!=null)
                this.oControlRandom.setValue(true);
            else
                this.oControlRandom.setValue(false);
        }
    },
    isValid: function () {
        return true;
    },
    getValue: function () {
        var oValue={};
        oValue.offset=this.oControlHour.getValue()*3600;
        oValue.offset+=this.oControlMinute.getValue()*60;
        var sDate=this.oDateTypeCylcer.getActiveItem().getItemId();
        switch(sDate)
        {
            case 'chk-time':
                oValue.timeBase='daily';
                break;
            case 'chk-sunset':
                oValue.timeBase='sunset';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            case 'chk-sunrise':
                oValue.timeBase='sunrise';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            case 'chk-dusk':
                oValue.timeBase='dusk';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            case 'chk-dawn':
                oValue.timeBase='dawn';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            default:
                oValue.timeBase=sDate;
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
        }
        if (this.oLimitType.getActiveItem().getItemId()=='chk-limitAfter') {
            oValue.limitAfter=this.oLimitMinute.getValue()*60;
            oValue.limitAfter+=this.oLimitHour.getValue()*3600;
        } else if (this.oLimitType.getActiveItem().getItemId()=='chk-limitBefore') {
            oValue.limitBefore=this.oLimitMinute.getValue()*60;
            oValue.limitBefore+=this.oLimitHour.getValue()*3600;
        }
        if (this.randomize!=null) {
            if (this.oControlRandom.getValue())
                oValue.random=this.randomize;
        }
        return oValue;
    }
});